package com.faraphel.tasks_valider

import android.annotation.SuppressLint
import android.os.Build
import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.annotation.RequiresApi
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import com.faraphel.tasks_valider.connectivity.bwf.BwfManager
import com.faraphel.tasks_valider.database.TaskDatabase
import com.faraphel.tasks_valider.ui.screen.scan.qr.ScanBarcodeScreen
import com.journeyapps.barcodescanner.BarcodeResult


class MainActivity : ComponentActivity() {
    private var bwfManager: BwfManager? = null  ///< the WiFi-Direct helper

    companion object {
        private lateinit var database: TaskDatabase  ///< the database manager
    }

    @RequiresApi(Build.VERSION_CODES.O)
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        this.setContent {
            @Composable
            fun example() {
                val barcode = remember { mutableStateOf<BarcodeResult?>(null) }
                if (barcode.value == null) ScanBarcodeScreen(this, barcode)
                else Text("code: ${barcode.value!!.text}")
            }

            example()
        }

        /*
        this.setContent {
            CommunicationScreen(this)
        }
        */
    }

    @SuppressLint("UnspecifiedRegisterReceiverFlag")
    override fun onResume() {
        super.onResume()

        // enable the WiFi-Direct events
        this.registerReceiver(this.bwfManager, BwfManager.ALL_INTENT_FILTER)
    }

    override fun onPause() {
        super.onPause()

        // disable the WiFi-Direct events
        this.unregisterReceiver(this.bwfManager)
    }
}
