package com.faraphel.tasks_valider.database

import androidx.room.Database
import androidx.room.RoomDatabase
import androidx.room.TypeConverters
import com.faraphel.tasks_valider.database.converters.InstantConverter
import com.faraphel.tasks_valider.database.dao.*
import com.faraphel.tasks_valider.database.entities.*


/**
 * The database for the tasks' application.
 * Contains the entities and the relations between them.
 */
@Database(
    entities = [
        ClassEntity::class,
        PersonEntity::class,
        SessionEntity::class,
        SubjectEntity::class,
        TaskEntity::class,
        ValidationEntity::class,

        RelationClassPersonEntity::class,
    ],
    version = 1
)
@TypeConverters(
    InstantConverter::class
)
abstract class TaskDatabase: RoomDatabase() {
    abstract fun classDao(): ClassDao
    abstract fun personDao(): PersonDao
    abstract fun sessionDao(): SessionDao
    abstract fun subjectDao(): SubjectDao
    abstract fun taskDao(): TaskDao
    abstract fun validationDao(): ValidationDao

    abstract fun relationClassPersonDao(): RelationClassPersonDao
}
