package com.faraphel.tasks_valider.database.entities

import androidx.compose.ui.text.capitalize
import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey
import com.faraphel.tasks_valider.database.entities.base.BaseEntity
import java.util.*

@Entity(tableName = PersonEntity.TABLE_NAME)
data class PersonEntity (
    @ColumnInfo("id") @PrimaryKey(autoGenerate = true) val id: Long = 0,
    @ColumnInfo("first_name") val firstName: String,
    @ColumnInfo("last_name") val lastName: String,
    @ColumnInfo("card_id") val cardId: UUID,
    @ColumnInfo("password_hash") val passwordHash: String
) : BaseEntity() {
    /**
     * Return the full name of the person
     */
    fun fullName(): String = "${this.firstName.capitalize()} ${this.lastName.uppercase()}"

    companion object {
        const val TABLE_NAME = "persons"
    }
}
