package com.faraphel.tasks_valider.database.entities

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.ForeignKey
import com.faraphel.tasks_valider.database.entities.base.BaseEntity
import java.time.Instant

@Entity(
    tableName = ValidationEntity.TABLE_NAME,
    primaryKeys = [
        "teacher_id",
        "student_id",
        "task_id",
    ],
    foreignKeys = [
        ForeignKey(
            entity = PersonEntity::class,
            parentColumns = ["id"],
            childColumns = ["teacher_id"],
            onDelete = ForeignKey.CASCADE
        ),
        ForeignKey(
            entity = PersonEntity::class,
            parentColumns = ["id"],
            childColumns = ["student_id"],
            onDelete = ForeignKey.CASCADE
        ),
        ForeignKey(
            entity = TaskEntity::class,
            parentColumns = ["id"],
            childColumns = ["task_id"],
            onDelete = ForeignKey.CASCADE
        ),
    ]
)
data class ValidationEntity (
    @ColumnInfo("date") val date: Instant,

    @ColumnInfo("teacher_id", index = true) val teacherId: Long,
    @ColumnInfo("student_id", index = true) val studentId: Long,
    @ColumnInfo("task_id", index = true) val taskId: Long,
) : BaseEntity() {
    companion object {
        const val TABLE_NAME = "validations"
    }
}

